/*-
|> File
|| handlreq.c
||
|> Description
||
|> Comments
||
|> History
||
||==================================================================|>
*/
#ifndef _NOIDENT
#ident "$Id: handlreq.c,v 2.6 1995/10/31 23:34:42 mreynold Exp $"
#endif

#include <stdio.h>
#include <malloc.h>
#include <string.h>

#define NEED_REPLIES    /* because Xproto.h is stupid and needs this */
#include <X11/Xproto.h>
#include <X11/Xlib.h>

#include "printer.h"
#include "printlib.h"
#include "printlibP.h"

#include "drawcmd.h"
#include "global.h"

static char *opNames[] = { 
    "No_Opcode",		     /* 0 */
    "X_CreateWindow",                /* 1 */
    "X_ChangeWindowAttributes",      /* 2 */
    "X_GetWindowAttributes",         /* 3 */
    "X_DestroyWindow",               /* 4 */
    "X_DestroySubwindows",           /* 5 */
    "X_ChangeSaveSet",               /* 6 */
    "X_ReparentWindow",              /* 7 */
    "X_MapWindow",                   /* 8 */
    "X_MapSubwindows",               /* 9 */
    "X_UnmapWindow",                 /* 10 */
    "X_UnmapSubwindows",             /* 11 */
    "X_ConfigureWindow",             /* 12 */
    "X_CirculateWindow",             /* 13 */
    "X_GetGeometry",                 /* 14 */
    "X_QueryTree",                   /* 15 */
    "X_InternAtom",                  /* 16 */
    "X_GetAtomName",                 /* 17 */
    "X_ChangeProperty",              /* 18 */
    "X_DeleteProperty",              /* 19 */
    "X_GetProperty",                 /* 20 */
    "X_ListProperties",              /* 21 */
    "X_SetSelectionOwner",           /* 22 */
    "X_GetSelectionOwner",           /* 23 */
    "X_ConvertSelection",            /* 24 */
    "X_SendEvent",                   /* 25 */
    "X_GrabPointer",                 /* 26 */
    "X_UngrabPointer",               /* 27 */
    "X_GrabButton",                  /* 28 */
    "X_UngrabButton",                /* 29 */
    "X_ChangeActivePointerGrab",     /* 30 */
    "X_GrabKeyboard",                /* 31 */
    "X_UngrabKeyboard",              /* 32 */
    "X_GrabKey",                     /* 33 */
    "X_UngrabKey",                   /* 34 */
    "X_AllowEvents",                 /* 35 */
    "X_GrabServer",                  /* 36 */
    "X_UngrabServer",                /* 37 */
    "X_QueryPointer",                /* 38 */
    "X_GetMotionEvents",             /* 39 */
    "X_TranslateCoords",             /* 40 */
    "X_WarpPointer",                 /* 41 */
    "X_SetInputFocus",               /* 42 */
    "X_GetInputFocus",               /* 43 */
    "X_QueryKeymap",                 /* 44 */
    "X_OpenFont",                    /* 45 */
    "X_CloseFont",                   /* 46 */
    "X_QueryFont",                   /* 47 */
    "X_QueryTextExtents",            /* 48 */
    "X_ListFonts",                   /* 49 */
    "X_ListFontsWithInfo",   	     /* 50 */
    "X_SetFontPath",                 /* 51 */
    "X_GetFontPath",                 /* 52 */
    "X_CreatePixmap",                /* 53 */
    "X_FreePixmap",                  /* 54 */
    "X_CreateGC",                    /* 55 */
    "X_ChangeGC ",                   /* 56 */
    "X_CopyGC ",                     /* 57 */
    "X_SetDashes",                   /* 58 */
    "X_SetClipRectangles",           /* 59 */
    "X_FreeGC",                      /* 60 */
    "X_ClearArea",                   /* 61 */
    "X_CopyArea",                    /* 62 */
    "X_CopyPlane",                   /* 63 */
    "X_PolyPoint",                   /* 64 */
    "X_PolyLine",                    /* 65 */
    "X_PolySegment",                 /* 66 */
    "X_PolyRectangle",               /* 67 */
    "X_PolyArc",                     /* 68 */
    "X_FillPoly",                    /* 69 */
    "X_PolyFillRectangle",           /* 70 */
    "X_PolyFillArc",                 /* 71 */
    "X_PutImage",                    /* 72 */
    "X_GetImage",                    /* 73 */
    "X_PolyText8"                    /* 74 */
    "X_PolyText16"                   /* 75 */
    "X_ImageText8"                   /* 76 */
    "X_ImageText16"                  /* 77 */
    "X_CreateColormap",              /* 78 */
    "X_FreeColormap",                /* 79 */
    "X_CopyColormapAndFree",         /* 80 */
    "X_InstallColormap",             /* 81 */
    "X_UninstallColormap",           /* 82 */
    "X_ListInstalledColormaps",      /* 83 */
    "X_AllocColor",                  /* 84 */
    "X_AllocNamedColor",             /* 85 */
    "X_AllocColorCells",             /* 86 */
    "X_AllocColorPlanes",            /* 87 */
    "X_FreeColors",                  /* 88 */
    "X_StoreColors",                 /* 89 */
    "X_StoreNamedColor",             /* 90 */
    "X_QueryColors",                 /* 91 */
    "X_LookupColor",                 /* 92 */
    "X_CreateCursor",                /* 93 */
    "X_CreateGlyphCursor",           /* 94 */
    "X_FreeCursor",                  /* 95 */
    "X_RecolorCursor",               /* 96 */
    "X_QueryBestSize",               /* 97 */
    "X_QueryExtension",              /* 98 */
    "X_ListExtensions",              /* 99 */
    "X_ChangeKeyboardMapping",       /* 100 */
    "X_GetKeyboardMapping",          /* 101 */
    "X_ChangeKeyboardControl",       /* 102 */
    "X_GetKeyboardControl",          /* 103 */
    "X_Bell",                        /* 104 */
    "X_ChangePointerControl",        /* 105 */
    "X_GetPointerControl",           /* 106 */
    "X_SetScreenSaver",              /* 107 */
    "X_GetScreenSaver",              /* 108 */
    "X_ChangeHosts",                 /* 109 */
    "X_ListHosts",                   /* 110 */
    "X_SetAccessControl",            /* 111 */
    "X_SetCloseDownMode",            /* 112 */
    "X_KillClient",                  /* 113 */
    "X_RotateProperties",	     /* 114 */
    "X_ForceScreenSaver",	     /* 115 */
    "X_SetPointerMapping",           /* 116 */
    "X_GetPointerMapping",           /* 117 */
    "X_SetModifierMapping",	     /* 118 */
    "X_GetModifierMapping",	     /* 119 */
    "X_NoOperation"                  /* 127 */
};

/*-=================================================================|>
||
|> Local functions
||
||==================================================================|>
||
*/

static                  atomPtr
getatom (
          const Atom atom,
          const atomTablePtr p_atomTable)

{
  int                     ii = 0;

  for (; ii < p_atomTable->numAtoms; ii++)
    if (p_atomTable->atomTable[ii].id == atom)
      return (&p_atomTable->atomTable[ii]);

  return 0;
}

/* set window attributes from a request */

static void
setWinattrs (
              XWindowAttributes *attr,
              unsigned long value_mask,
              unsigned long *request)

{
  if (value_mask & CWBitGravity)
  {
    attr->bit_gravity = *request++;
  }
  if (value_mask & CWWinGravity)
  {
    attr->win_gravity = *request++;
  }
  if (value_mask & CWBackingStore)
  {
    attr->backing_store = *request++;
  }
  if (value_mask & CWBackingPlanes)
  {
    attr->backing_planes = *request++;
  }
  if (value_mask & CWBackingPixel)
  {
    attr->backing_pixel = *request++;
  }
  if (value_mask & CWOverrideRedirect)
  {
    attr->override_redirect = *request++;
  }
  if (value_mask & CWSaveUnder)
  {
    attr->save_under = *request++;
  }
  if (value_mask & CWDontPropagate)
  {
    attr->do_not_propagate_mask = *request++;
  }
  if (value_mask & CWColormap)
  {
    attr->colormap = *request++;
  }
  /*- Why are these commented out? because we don't care about cursors and
    event masks.  The BackPixmap, BackPixel, and BorderPixmap stuff
    probably shouldn't be commented out 
  */
#if 0
  if (value_mask & CWEventMask)
  {
    attr->event_mask = *request++;
  }
#endif
#if 0
  if (value_mask & CWCursor)
  {
    attr->cursor = *request++;
  }
#endif
#if 0
  if (value_mask & CWBackPixmap)
  {
    attr->background_pixmap = *request++;
  }
  if (value_mask & CWBackPixel)
  {
    attr->background_pixel = *request++;
  }
  if (value_mask & CWBorderPixmap)
  {
    attr->border_pixmap = *request++;
  }
#endif
}

/* delete a window from a table of windows */
static void
deleteWin (
            const winfoTablePtr table,
            const unsigned long win)

{
  int                     ii = 0,
                          jj = 0;

  for (; ii < table->numWin; ii++)
    if (table->winTable[ii].win != win)
      table->winTable[jj++] = table->winTable[ii];

  table->numWin = jj;
}

/* delete a GC from a table of GCs */

static void
deleteGc (
           const gcinfoTablePtr table,
           const unsigned long gcid)

{
  int                     ii = 0,
                          jj = 0;

  for (; ii < table->numGc; ii++)
    if (table->gcTable[ii].gcid != gcid)
      table->gcTable[jj++] = table->gcTable[ii];

  table->numGc = jj;
}

/* delete a colormap from a table of colormaps */

static void
deleteCmap (
             const cmapinfoTablePtr table,
             const unsigned long cmap)

{
  int                     ii = 0,
                          jj = 0;

  for (; ii < table->numCmap; ii++)
    if (table->cmapTable[ii].cmap != cmap)
      table->cmapTable[jj++] = table->cmapTable[ii];

  table->numCmap = jj;
}

/*-=================================================================|>
||
|> Public functions
||
||==================================================================|>
||
|> Function
|| cmapinfoPtr
||
|> Description
|| get the colormap attributes corresponding to a colormap id.
||
|> Comments
|| None.
||
|> Parameters
|| -void.
||
|> Returns
|| Returns void.
||
|> Exits
|| Exits if:
||
|> Limits
||   
||
||==================================================================|>
*/

cmapinfoPtr
getcmapinfo (
              const unsigned long cmap,
              const cmapinfoTablePtr table)

{
  int                     i = 0;

  for (; i < table->numCmap; i++)
    if (table->cmapTable[i].cmap == cmap)
      return (&(table->cmapTable[i]));

/*-
   set the pixels and allocation for this colormap.  We allow writeable
   flags all the time, because we don't care about multiple clients  
   sharing colormap, set the writeable flags to false.
*/

  for (i = 0; i < NUM_COLORS; i++)
    table->cmapTable[table->numCmap].colors[i].pixel = i,
      table->cmapTable[table->numCmap].numAlloc[i] = 0,
      table->cmapTable[table->numCmap].writeable[i] = TRUE;

  table->cmapTable[table->numCmap++].cmap = cmap;
  return (&table->cmapTable[table->numCmap - 1]);
}

/* initialize the window, GC, colormap, atom, and font tables */

void initTables()
{
    int  ii;

    winfoTable = (winfoTablePtr) malloc (sizeof (winfoTableRec));
    winfoTable->winTable = (winfoPtr) malloc (sizeof (winfoRec) * NUMWIN);
    winfoTable->numWin = 1;
    winfoTable->winTable[0].win = 0;
    winfoTable->winTable[0].attr = initial_Attrs;
    gcinfoTable = (gcinfoTablePtr) malloc (sizeof (gcinfoTableRec));
    gcinfoTable->gcTable = (gcinfoPtr) malloc (sizeof (gcinfoRec) * NUMGC);
    gcinfoTable->numGc = 0;
    cmapinfoTable =
      (cmapinfoTablePtr) malloc (sizeof (cmapinfoTableRec));
    cmapinfoTable->cmapTable =
      (cmapinfoPtr) malloc (sizeof (cmapinfoRec) * NUMGC);
    cmapinfoTable->numCmap = 0;
    atomTable = (atomTablePtr) malloc (sizeof (atomTableRec));
    atomTable->atomTable = (atomPtr) malloc (sizeof (atomRec) * NUMATOM);
    atomTable->numAtoms = 0;
    fontTable = (fontTablePtr) malloc (sizeof (fontTableRec));
    fontTable->fontTable = (fontPtr) malloc (sizeof (fontRec) * NUMFONT);
    fontTable->numFonts = 0;

    /* create the 8-bit pseudoColor DefaultColormap */
    
    cmapinfoTable->numCmap = 1;
    cmapinfoTable->cmapTable[ 0].visualID = PSEUDOCOLOR_VISUAL;
    cmapinfoTable->cmapTable[ 0].cmap =
	DefaultColormap( THE_DISPLAY, DefaultScreen( THE_DISPLAY));
    cmapinfoTable->cmapTable[ 0].numColors = NUM_COLORS;
    for ( ii = 0; ii < NUM_COLORS; ii++) {
        cmapinfoTable->cmapTable[ 0].colors[ ii].pixel = ii;
	cmapinfoTable->cmapTable[ 0].numAlloc[ ii] = 0;
	cmapinfoTable->cmapTable[ 0].writeable[ ii] = TRUE;
    }
}

/*-
|> Function
|| getgcinfo
||
|> Description
|| get the GC attributes corresponding to a GC id.
||
|> Comments
|| None.
||
|> Parameters
|| -void.
||
|> Returns
|| Returns void.
||
|> Exits
|| Exits if:
||
|> Limits
||   
||
||==================================================================|>
*/

gcinfoPtr
getgcinfo (
            const unsigned long gcid,
            const gcinfoTablePtr table)

{
  int                     i;

  for (i = 0; i < table->numGc; i++)
    if (table->gcTable[i].gcid == gcid)
      return (&(table->gcTable[i]));

  return 0;
}

/* get the window attributes corresponding to a window */

winfoPtr
getwinfo (
           const unsigned long win,
           const winfoTablePtr table)

{
  int                     ii = 0;

  for (; ii < table->numWin; ii++)
    if (table->winTable[ii].win == win)
      return (&(table->winTable[ii]));

/* this probably indicates that the window is on the REAL server */

  return 0;
}

/*-
|> Function
|| HandleX_Request
||
|> Description
|| lib. 
||
|> Comments
|| None.
||
|> Parameters
|| -void.
||
|> Returns
|| Returns int
||
|> Exits
|| Exits if:
||
|> Limits
||   
||
||==================================================================|>
*/

int
HandleX_Request (
                  unsigned char *const buf,
                  unsigned char *newmsg,
                  int *newlen,
                  const int request,
                  const FD fd)

{
  unsigned char           flag;
  XGCValues              *gcvp;
  int                     nrect,
                          nextensions;
  winfoPtr                winfo;
  gcinfoPtr               gcinfo;
  cmapinfoPtr             cmapinfo;
  atomPtr                 atom;
  FILE                   *printFp = PCS[fd].printfp;

  switch (request)
  {
  case X_CreateWindow:
    {
      xCreateWindowReq       *req = (xCreateWindowReq *) buf;
      XWindowAttributes      *attr;
      const int               ind = winfoTable->numWin++;

      winfoTable->winTable[ind].created = TRUE;
      winfoTable->winTable[ind].win = req->wid;
      winfoTable->winTable[ind].parent = req->parent;
      winfoTable->winTable[ind].fd = fd;
      memcpy ((void *) &winfoTable->winTable[ind].attr,
              (void *) &initial_Attrs, sizeof (XWindowAttributes));

      attr = &winfoTable->winTable[ind].attr;
      attr->x = req->x;
      attr->y = req->y;
      attr->width = req->width;
      attr->height = req->height;
      attr->class = req->class;
      attr->colormap =
        DefaultColormap (THE_DISPLAY, DefaultScreen (THE_DISPLAY));

      setWinattrs (attr, req->mask,
                   (unsigned long *)
                   (buf + sizeof (xCreateWindowReq)));
    }
    return 0;                   /* don't forward the request */
    break;

  case X_ChangeWindowAttributes:
    {
      xChangeWindowAttributesReq *req =
      (xChangeWindowAttributesReq *) buf;

      if ((winfo = getwinfo (PCS[fd].win, winfoTable)))
      {
        setWinattrs (&winfo->attr, req->valueMask,
                     (unsigned long *)
                     (buf +
                      sizeof (xChangeWindowAttributesReq)));
      }
      else
        fprintf (stderr,
                 "X_ChangeWindowAttributes bad window %ld\n",
                 req->window);
    }
    break;

  case X_GetWindowAttributes:
    {
      xResourceReq           *req = (xResourceReq *) buf;
      xGetWindowAttributesReply *reply =
      (xGetWindowAttributesReply *) newmsg;

      if ((winfo = getwinfo (req->id, winfoTable)))
      {
        reply->backingStore = winfo->attr.backing_store;
        reply->length = 3;
        reply->class = winfo->attr.class;
        reply->bitGravity = winfo->attr.bit_gravity;
        reply->winGravity = winfo->attr.win_gravity;
        reply->backingBitPlanes = winfo->attr.backing_planes;
        reply->backingPixel = winfo->attr.backing_pixel;
        reply->saveUnder = winfo->attr.save_under;
        reply->colormap = winfo->attr.colormap;
        reply->allEventMasks = winfo->attr.all_event_masks;
        reply->doNotPropagateMask =
          winfo->attr.do_not_propagate_mask;
        *newlen = sizeof (*reply);
      }
      else
        fprintf (stderr, "X_GetWindowAttributes bad window %ld\n",
                 req->id);
    }
    break;

  case X_DestroyWindow:
    {
      xResourceReq           *req = (xResourceReq *) buf;

      deleteWin (winfoTable, req->id);
    }
    break;

  case X_GetGeometry:
    {
      xResourceReq           *req = (xResourceReq *) buf;
      xGetGeometryReply      *reply = (xGetGeometryReply *) newmsg;

      if ((winfo = getwinfo (req->id, winfoTable)))
      {
        reply->x = winfo->attr.x;
        reply->y = winfo->attr.y;
        reply->width = winfo->attr.width;
        reply->height = winfo->attr.height;
        reply->depth = winfo->attr.depth;
        reply->length = 0;
        reply->root = winfoTable->winTable[0].win;
        reply->borderWidth = winfo->attr.border_width;
        *newlen = sizeof (*reply);
      }
      else
        fprintf (stderr, "X_GetGeometry bad window id %ld\n",
                 req->id);
    }
    break;

  case X_QueryTree:
    {
      xResourceReq           *req = (xResourceReq *) buf;
      xQueryTreeReply        *reply = (xQueryTreeReply *) newmsg;

      if ((winfo = getwinfo (req->id, winfoTable)))
      {
        reply->root = winfoTable->winTable[0].win;
        reply->parent = winfo->parent;

/* FTM, number of children is zero */

        reply->nChildren = 0;
        reply->length = 0;
        *newlen = sizeof (*reply);
      }
      else
        fprintf (stderr, "X_QueryTree bad window id %ld\n",
                 req->id);
    }
    break;

  case X_InternAtom:
    {
      xInternAtomReq         *req = (xInternAtomReq *) buf;
      xInternAtomReply       *reply = (xInternAtomReply *) newmsg;

      atomTable->atomTable[atomTable->numAtoms].id =
        atomTable->numAtoms;
      atomTable->atomTable[atomTable->numAtoms].name =
        (char *) malloc (req->nbytes + 1);
      strncpy (atomTable->atomTable[atomTable->numAtoms].name,
               (char *) buf + sizeof (*req), req->nbytes + 1);
      reply->atom = atomTable->numAtoms++;
      *newlen = sizeof (*reply);
    }
    break;

  case X_GetAtomName:
    {
      xResourceReq           *req = (xResourceReq *) buf;
      xGetAtomNameReply      *reply = (xGetAtomNameReply *) newmsg;

      if ((atom = getatom (req->id, atomTable)))
      {
        reply->nameLength = strlen (atom->name);
        strncpy ((char *) newmsg + sizeof (*reply),
                 (char *) newmsg, reply->nameLength);
      }
      else
        reply->nameLength = 0;

      *newlen = sizeof (*reply);
    }
    break;

  case X_GetProperty:
    {
/* FTM, don't return ANY properties */
      xGetPropertyReply      *reply = (xGetPropertyReply *) newmsg;

      reply->propertyType = None;
      reply->bytesAfter = 0;
      reply->length = 0;
      reply->format = 0;
      reply->nItems = 0;
      *newlen = sizeof (*reply);
    }
    break;

  case X_ListProperties:
    {
      xListPropertiesReply   *reply =
      (xListPropertiesReply *) newmsg;

      reply->nProperties = 0;
      *newlen = sizeof (*reply);
    }
    break;

  case X_GetSelectionOwner:
    {
      xGetSelectionOwnerReply *reply =
      (xGetSelectionOwnerReply *) newmsg;

      reply->owner = 0;
      *newlen = sizeof (*reply);
    }
    break;

  case X_GrabPointer:
    {
      xGrabPointerReply      *reply = (xGrabPointerReply *) newmsg;

      reply->status = False;
      *newlen = sizeof (*reply);
    }
    break;

  case X_GrabKeyboard:
    {
      xGrabKeyboardReply     *reply = (xGrabKeyboardReply *) newmsg;

      reply->status = False;
      *newlen = sizeof (*reply);
    }
    break;

	/* obviously, this is truly bogus, but they shouldn't be querying */
	/* the pointer from this server anyway */
	  
  case X_QueryPointer:
    {
      xQueryPointerReply     *reply = (xQueryPointerReply *) newmsg;

      reply->root = reply->child = 0,
        reply->rootX = reply->rootY =
        reply->winX = reply->winY = 0;

      *newlen = sizeof (*reply);
    }
    break;

  case X_GetMotionEvents:
    {
      xGetMotionEventsReply  *reply =
      (xGetMotionEventsReply *) newmsg;

      reply->nEvents = 0;
      *newlen = sizeof (*reply);
    }
    break;

  case X_TranslateCoords:
    {
      xTranslateCoordsReply  *reply =
      (xTranslateCoordsReply *) newmsg;

      reply->dstX = 0;
      reply->dstY = 0;
      *newlen = sizeof (*reply);
    }
    break;

  case X_GetInputFocus:
    {
      xGetInputFocusReply    *reply =
      (xGetInputFocusReply *) newmsg;

      reply->focus = 0;         /* make it the root window */
      reply->revertTo = None;
      reply->length = 0;        /* the documentation says this is 0 */
      *newlen = sizeof (*reply);
    }
    break;

/* add the font to the font cache. */
  case X_OpenFont:
    {
      xOpenFontReq           *req = (xOpenFontReq *) buf;
      char                   *fontName =
      (char *) buf + sizeof (xOpenFontReq);
      int                     found = FALSE,
                              n = fontTable->numFonts;
      fontPtr                 font;
      int                     ii = 0;

      for (; ii < fontTable->numFonts; ii++)
        if (!strncmp (fontTable->fontTable[ii].xfontName,
                      fontName, req->nbytes))
        {
          found = TRUE;
          break;
        }

/* save the name and font ID, get the postscript name for the font, 
   then query the font for the font struct information */

      if (!found)
      {
        font = &fontTable->fontTable[n];
        font->fd = fd;
        font->nfid = 1;
        font->fid[0] = req->fid;
        font->serverFid = 0;
        font->xfontName = (char *) malloc (req->nbytes + 1);

/* terminate that bad-boy */

        strncpy (font->xfontName, fontName, req->nbytes);
	font->xfontName[ req->nbytes] = '\0';
        if (!(font->postName = getPostName (font->xfontName)))
        {
          fprintf (stderr, "PostScript font for X %s not found\n",
                   font->xfontName);
        }

        if (!(font->fontInfo =
              XLoadQueryFont (THE_DISPLAY, font->xfontName)))
        {
          fprintf (stderr, "X font %s not found\n",
                   font->xfontName);
        }
        fontTable->numFonts++;
      }
      else
      {
        int                     jj = 0;

/* multiple font ID's may be assigned to a font name */

        found = FALSE;
        font = &fontTable->fontTable[ii];
        for (jj = 0; jj < font->nfid; jj++)
          if (font->fid[jj] == req->fid)
          {
            found = TRUE;
            break;
          }

        if (!found)
          font->fid[font->nfid++] = req->fid;
      }
    }
    break;

  case X_QueryFont:           /* needs reply */
    {
      xResourceReq           *req = (xResourceReq *) buf;
      xQueryFontReply        *reply = (xQueryFontReply *) newmsg;
      XFontStruct            *font_struct;
      int                     found = FALSE,
                              ii = 0,
                              jj;
      char		     *ptr;

      for (; ii < fontTable->numFonts; ii++)
        for (jj = 0; jj < fontTable->fontTable[ii].nfid; jj++)
          if (fontTable->fontTable[ii].fid[jj] == req->id)
          {
            found = TRUE;
            goto hideous_goto_label;
          }

    hideous_goto_label:

/* if the font is not loaded on the server, we have to load it before
   querying the font */

      if (!found)
      {
        fprintf (stderr, "font ID %ld not found\n", req->id);
        reply->length =
          (sizeof (xQueryFontReply) - sizeof (xReply)) >> 2;
        reply->nFontProps = 0;
        reply->nCharInfos = 0;
        *newlen = sizeof (*reply);
      }
      else
      {

/* load the font from the server that we're going to query, then just
   pass on the information from the server. */

        if (!fontTable->fontTable[ii].serverFid)
        {
          fontTable->fontTable[ii].serverFid =
            XLoadFont (THE_DISPLAY,
                       fontTable->fontTable[ii].xfontName);
        }
        font_struct =
          XQueryFont (THE_DISPLAY,
                      fontTable->fontTable[ii].serverFid);

/* copy the the fontInfo from the font_struct from the real server */

        reply->minBounds = *(xCharInfo *) & font_struct->min_bounds;
        reply->maxBounds = *(xCharInfo *) & font_struct->max_bounds;
        reply->minCharOrByte2 = font_struct->min_char_or_byte2;
        reply->maxCharOrByte2 = font_struct->max_char_or_byte2;
        reply->defaultChar = font_struct->default_char;
        reply->nFontProps = font_struct->n_properties;
        reply->drawDirection = font_struct->direction;
        reply->minByte1 = font_struct->min_byte1;
        reply->maxByte1 = font_struct->max_byte1;
        reply->allCharsExist = font_struct->all_chars_exist;
        reply->fontAscent = font_struct->ascent;
        reply->fontDescent = font_struct->descent;
        reply->nCharInfos = font_struct->max_char_or_byte2 -
          font_struct->min_char_or_byte2;

/* copy the fontprop + charinfo structures */
 
        ptr = (( char *) reply) + sizeof( xQueryFontReply);
	memcpy ((void *) ptr,
                (void *) font_struct->properties,
                sizeof( xFontProp)*reply->nFontProps);
        memcpy ((void *) (ptr + sizeof( xFontProp)*reply->nFontProps),
                (void *) font_struct->per_char,
                sizeof( xCharInfo)*reply->nCharInfos);
        *newlen = sizeof (*reply) +
          sizeof( xCharInfo)*reply->nCharInfos +
          sizeof( xFontProp)*reply->nFontProps;
        reply->length = 7 + reply->nFontProps * 2 + reply->nCharInfos * 3;
      }
    }
    break;

  case X_QueryTextExtents:      /* needs reply */
    {
      xQueryTextExtentsReq   *req =
      (xQueryTextExtentsReq *) buf;
      xQueryTextExtentsReply *reply =
      (xQueryTextExtentsReply *) newmsg;
      int                     nchars,
                              dir,
                              ascent,
                              descent,
                              found = FALSE;
      XCharStruct             overall;
      int                     ii = 0,
                              jj;

      for (; ii < fontTable->numFonts; ii++)
      {
        for (jj = 0; jj < fontTable->fontTable[ii].nfid; jj++)
        {
          if (fontTable->fontTable[ii].fid[jj] != req->fid)
          {
            found = TRUE;
            goto butt_ugly_goto_label;

          }
        }
      }
    butt_ugly_goto_label:

      if (!fontTable->fontTable[ii].serverFid)
      {
        fontTable->fontTable[ii].serverFid =
          XLoadFont (THE_DISPLAY,
                     fontTable->fontTable[ii].xfontName);
      }
      nchars = (req->length >> 1) - req->oddLength;
      XQueryTextExtents16 (THE_DISPLAY,
                           fontTable->fontTable[ii].serverFid,
                           (XChar2b *) buf + sizeof (*req),
                           nchars, &dir, &ascent, &descent, &overall);
      reply->fontAscent = ascent;
      reply->fontDescent = descent;
      reply->overallAscent = overall.ascent;
      reply->overallDescent = overall.descent;
      reply->overallWidth = overall.width;
      reply->overallLeft = overall.lbearing;
      reply->overallRight = overall.rbearing;
      *newlen = sizeof (*reply);
    }
    break;

  case X_ListFonts:           /* needs reply */
    {
      xListFontsReq          *req = (xListFontsReq *) buf;
      xListFontsReply        *reply = (xListFontsReply *) newmsg;
      char                  **fonts;
      unsigned char          *ptr = buf + sizeof (*reply);
      int                     ii, length = 0, nfonts, n;

      fonts = XListFonts (THE_DISPLAY,
                          (char *) buf + sizeof (*req),
                          req->maxNames, &nfonts);
      reply->nFonts = nfonts;
      for ( ii = 0; ii < nfonts; ii++)
      {
	n = strlen( fonts[ ii]);
	ptr[ length++] = n;
	memcpy(( void *) &ptr[ length], ( void *) fonts[ ii], n);
	length += n;
      }
      XFreeFontNames( fonts);
      reply->length = (length + 3) >> 2;
      *newlen = sizeof (*reply) + (reply->length << 2);
    }
    break;

  case X_ListFontsWithInfo:   /* needs reply */
    {
      xListFontsWithInfoReq  *req =
      (xListFontsWithInfoReq *) buf;
      xListFontsWithInfoReply *reply =
      (xListFontsWithInfoReply *) newmsg;
      char                  **fonts;
      int                     ii = 0,
                              nfonts;
      XFontStruct            *finfoVec;

      *newlen = 0;
      fonts = XListFontsWithInfo (THE_DISPLAY,
                                  (char *) buf + sizeof (*req),
                                  req->maxNames, &nfonts,
                                  &finfoVec);

/* this generates a set of replies.  Right now, all I do is write then,
   but there's a high likelihood of overflow */

      for (; ii < nfonts; ii++)
      {
        reply->nameLength = strlen (fonts[ii]) + 1;
        reply->minBounds =
          *(xCharInfo *) & finfoVec[ii].min_bounds;
        reply->maxBounds =
          *(xCharInfo *) & finfoVec[ii].max_bounds;
        reply->minCharOrByte2 = finfoVec[ii].min_char_or_byte2;
        reply->maxCharOrByte2 = finfoVec[ii].max_char_or_byte2;
        reply->defaultChar = finfoVec[ii].default_char;
        reply->nFontProps = finfoVec[ii].n_properties;
        reply->drawDirection = finfoVec[ii].direction;
        reply->minByte1 = finfoVec[ii].min_byte1;
        reply->maxByte1 = finfoVec[ii].max_byte1;
        reply->allCharsExist = finfoVec[ii].all_chars_exist;
        reply->fontAscent = finfoVec[ii].ascent;
        reply->fontDescent = finfoVec[ii].descent;
        reply->nReplies = nfonts - (ii + 1);

/* copy the propertyu structures, but not char infos */

        memcpy ((void *) (req + sizeof (xQueryFontReply)),
                (void *) finfoVec[ii].properties,
                sizeof (xFontProp) * reply->nFontProps);

/* copy the name of the font */

        strcpy ((char *) req + sizeof (xQueryFontReply) +
                sizeof (xFontProp) * reply->nFontProps,
                fonts[ii]);
        *newlen += sizeof (*reply) + strlen (fonts[ii]) + 1 +
          sizeof (xFontProp) * reply->nFontProps;
        reply = (xListFontsWithInfoReply *) (buf + pad (*newlen));
      }

/* nameLength = 0 implies end of sequence */

      reply->nameLength = 0;
      *newlen += sizeof (reply);
    }
    break;

  case X_GetFontPath:         /* needs reply */
    {
      xReq                   *req = (xReq *) buf;
      xGetFontPathReply      *reply =
      (xGetFontPathReply *) newmsg;
      char                  **paths;
      unsigned char          *ptr = buf + sizeof (*req);
      int                     npaths,
                              ii = 0,
                              length = 0;

      paths = XGetFontPath (THE_DISPLAY, &npaths);
      reply->nPaths = npaths;
      for (; ii < npaths; ii++, ptr += strlen (paths[ii]) + 1)
      {
        length += strlen (paths[ii]) + 1;
        strcpy ((char *) ptr, paths[ii]);
      }
      reply->length = (length + 3) >> 2;
      *newlen = sizeof (*reply) + (length << 2);
    }
    break;

  case X_FreePixmap:
    {
      xResourceReq           *req = (xResourceReq *) buf;

      deleteWin (winfoTable, req->id);
    }
    break;

/*- Copy the standard GC, then use the flags to get the
|| attributes from the message.
*/
  case X_CreateGC:
    {
      xCreateGCReq           *req = (xCreateGCReq *) buf;
      const int               ind = gcinfoTable->numGc++;

      gcinfoTable->gcTable[ind].attr = initial_GC;
      gcinfoTable->gcTable[ind].gcid = req->gc;
      gcinfoTable->gcTable[ind].clipRects = NULL;
      gcinfoTable->gcTable[ind].numClipRects = 0;
      gcinfoTable->gcTable[ind].fd = fd;
      gcvp = &(gcinfoTable->gcTable[ind].attr);

/* pull out the value mask and use it to get the values from the request, 
   set a pointer into the values section of the request */

      if ((winfo = getwinfo (req->drawable, winfoTable)))
        setGcvalues (fd, printFp, gcvp, req->mask,
                     (unsigned long *)
                     (buf + sizeof (xCreateGCReq)),
                     winfo->attr.colormap);
      else
        fprintf (stderr, "X_CreateGC: bad window id %ld\n",
                 req->drawable);
    }
    break;

  case X_ChangeGC:
    {
      xChangeGCReq           *req = (xChangeGCReq *) buf;

/* have to intercept these, because there's no other way to get the info 
   send the print window down for the colormap for setcolor */

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
      {
        winfo = getwinfo (PCS[fd].win, winfoTable);
        setGcvalues (fd, printFp, &gcinfo->attr, req->mask,
                     (unsigned long *)
                     (buf + sizeof (xChangeGCReq)),
                     winfo->attr.colormap);
      }
      else
        fprintf (stderr, "X_ChangeGC bad GC %ld\n", req->gc);
    }
    break;

  case X_CopyGC:
    {
      xCopyGCReq             *req = (xCopyGCReq *) buf;
      gcinfoPtr               gcinfo2 = getgcinfo (req->dstGC, gcinfoTable);

      gcinfo = getgcinfo (req->srcGC, gcinfoTable);

      if (gcinfo && gcinfo2)
        copyGcvalues (&gcinfo->attr, &gcinfo2->attr, req->mask);
    }
    break;

  case X_SetDashes:
    {
      xSetDashesReq          *req = (xSetDashesReq *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
      {
        gcvp = &(gcinfo->attr);
        gcvp->dash_offset = req->dashOffset;
        gcinfo->numDashes = req->nDashes;
        gcinfo->dashes = (char *) malloc (req->nDashes);
        memcpy (gcinfo->dashes, buf + sizeof (*req),
                gcinfo->numDashes);
      }
      else
        fprintf (stderr, "X_SetDashes bad GC %ld\n", req->gc);
    }
    break;

  case X_SetClipRectangles:
    {
      xSetClipRectanglesReq  *req =
      (xSetClipRectanglesReq *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
      {
        gcvp = &(gcinfo->attr);

/* set the clip x and y origin */

        gcvp->clip_x_origin = req->xOrigin;
        gcvp->clip_y_origin = req->yOrigin;

/* then copy the clip rectangles */

        if (gcinfo->clipRects)
        {
          free (gcinfo->clipRects);
        }
        nrect = (req->length - 3) >> 1;
        gcinfo->clipRects =
          (XRectangle *) malloc (sizeof (XRectangle) * nrect);

        memcpy (gcinfo->clipRects,
                buf + sizeof (xSetClipRectanglesReq),
                nrect * sizeof (XRectangle));

        gcinfo->numClipRects = nrect;
      }
      else
        fprintf (stderr, "X_SetClipRectangles bad GC %ld\n",
                 req->gc);
    }
    break;

  case X_FreeGC:
    {
      xResourceReq           *req = (xResourceReq *) buf;

      deleteGc (gcinfoTable, req->id);
      break;
    }
    break;

  case X_ClearArea:
    {
      xClearAreaReq          *req = (xClearAreaReq *) buf;

      if ((winfo = getwinfo (req->window, winfoTable)))
        cleararea (printFp, req->window, &(winfo->attr),
                   req->x, req->y, req->width, req->height);
      else
        fprintf (stderr, "X_ClearArea: bad window ID %ld\n",
                 req->window);
    }
    break;

  case X_CopyArea:
    {
      xCopyAreaReq           *req = (xCopyAreaReq *) buf;

      if ((winfo = getwinfo (req->dstDrawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        copyarea (printFp, req->srcDrawable, req->dstDrawable,
                  req->srcX, req->srcY, req->dstX, req->dstY,
                  req->width, req->height,
                  NUM_COLORS, cmapinfo->colors);
      }
      else
        fprintf (stderr, "X_CopyArea: bad window ID %ld\n",
                 req->dstDrawable);
    }
    break;

  case X_PolyPoint:
    {
      xPolyPointReq          *req = (xPolyPointReq *) buf;

      flag = req->coordMode;
      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_Polyline bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }

      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        polypoint (printFp, req->drawable, gcvp,
                   req->length - 3, (int) req->coordMode,
                   (XPoint *) (buf + sizeof (xPolyPointReq)));
      }
      else
        fprintf (stderr, "X_PolyPoint: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_PolyLine:
    {
      xPolyLineReq           *req = (xPolyLineReq *) buf;

      flag = req->coordMode;
      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_Polyline bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }

      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        polyline (printFp, req->drawable, gcvp,
                  req->length - 3, (int) req->coordMode,
                  (XPoint *) (buf + sizeof (xPolyLineReq)));
      }
      else
        fprintf (stderr, "X_PolyLine: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_PolySegment:
    {
      xPolySegmentReq        *req = (xPolySegmentReq *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_PolySegment bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }

      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        polysegment (printFp, req->drawable, gcvp,
                     (req->length - 3) >> 1,
                     (XSegment *)
                     (buf + sizeof (xPolySegmentReq)));
      }
      else
        fprintf (stderr, "X_PolySegment: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_PolyRectangle:
    {
      xPolyRectangleReq      *req = (xPolyRectangleReq *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_PolyRectangle bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }

      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        polyrectangle (printFp, req->drawable, gcvp,
                       (req->length - 3) >> 1,
                       (XRectangle *)
                       (buf + sizeof (xPolyRectangleReq)));
      }
      else
        fprintf (stderr, "X_PolyRectangle: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_PolyArc:
    {
      xPolyArcReq            *req = (xPolyArcReq *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_PolyArc bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }

      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        polyarc (printFp, req->drawable, gcvp, (req->length - 3) / 3,
                 (xArc *) (buf + sizeof (xPolyArcReq)));
      }
      else
        fprintf (stderr, "X_PolyArc: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_FillPoly:
    {
      xFillPolyReq           *req = (xFillPolyReq *) buf;

/* flag for coordinate mode */

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_FillPoly bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }

      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        fillpoly (printFp, req->drawable, &(gcinfo->attr),
                  req->length - 4, req->coordMode,
                  (XPoint *) (buf + sizeof (xFillPolyReq)));
      }
      else
      {
        fprintf (stderr, "X_PolyRectangle: bad window ID %ld\n",
                 req->drawable);
      }
    }
    break;

  case X_PolyFillRectangle:
    {
      xPolyRectangleReq      *req = (xPolyRectangleReq *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_PolyFillRectangle bad GC %ld\n",
                 req->gc);
        gcvp = &initial_GC;
      }

      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        polyfillrectangle (printFp, req->drawable, gcvp,
                           (req->length - 3) >> 1,
                           (XRectangle *)
                           (buf + sizeof (xPolyRectangleReq)));
      }
      else
        fprintf (stderr, "X_PolyFillRectangle: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_PutImage:
    {
      xPutImageReq           *req = (xPutImageReq *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable))) {
        gcvp = &gcinfo->attr;
      } else {
        fprintf (stderr, "X_PutImage bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }

/* get the window's colormap so we know what colors to use for the image */

      if ((winfo = getwinfo (req->drawable, winfoTable))) {
        cmapinfo = getcmapinfo (winfo->attr.colormap, cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
	putimage (fd, printFp, req->drawable, gcvp,
		  req->depth, req->width, req->height,
		  req->dstX, req->dstY, req->pad, req->format,
		  NUM_COLORS, cmapinfo->colors,
		  buf + sizeof (xPutImageReq));
      } else {
        fprintf (stderr, "X_PutImage: bad window ID %ld\n",
                 req->drawable);
      }
    }
    break;

/* GetImage is totally kludged,  It sends back an entirely blank image */

  case X_GetImage:              /* needs reply */
    {
      xGetImageReq           *req = (xGetImageReq *) buf;
      xGetImageReply         *reply = (xGetImageReply *) newmsg;

      reply->depth = 8;
      reply->length = req->width * req->height * 2;
      *newlen = sizeof (*reply) + reply->length * 2;
    }
    break;

  case X_PolyText8:
    {
      xPolyText8Req          *req = (xPolyText8Req *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_PolyText8 bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }
      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        polytext8 (printFp, req->drawable, gcvp, req->x, req->y,
                   (req->length * 4) - sizeof (xPolyText8Req),
                   buf + sizeof (xPolyText8Req));
      }
      else
        fprintf (stderr, "X_PolyText8: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_PolyText16:
    {
      xPolyText16Req         *req = (xPolyText16Req *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_PolyText16 bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }
      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        polytext16 (printFp, req->drawable, gcvp, req->x, req->y,
                    (req->length - 4) >> 2,
                    buf + sizeof (xPolyText16Req));
      }
      else
        fprintf (stderr, "X_PolyText8: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_ImageText8:
    {
      xImageText8Req         *req = (xImageText8Req *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_ImageText8 bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }
      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        imagetext8 (printFp, req->drawable, gcvp, req->x, req->y,
                    (req->length * 4) - sizeof (xPolyText8Req),
                    buf + sizeof (xImageText8Req));
      }
      else
        fprintf (stderr, "X_ImageText8: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_ImageText16:
    {
      xImageText16Req        *req = (xImageText16Req *) buf;

      if ((gcinfo = getgcinfo (req->gc, gcinfoTable)))
        gcvp = &gcinfo->attr;
      else
      {
        fprintf (stderr, "X_ImageText16 bad GC %ld\n", req->gc);
        gcvp = &initial_GC;
      }

      if ((winfo = getwinfo (req->drawable, winfoTable)))
      {
        cmapinfo = getcmapinfo (winfo->attr.colormap,
                                cmapinfoTable);
        setCurrGc (fd, printFp, gcinfo, cmapinfo->cmap);
        imagetext16 (printFp, req->drawable, gcvp, req->x, req->y,
                     (req->length - 4) >> 2,
                     buf + sizeof (xImageText16Req));
      }
      else
        fprintf (stderr, "X_ImageText16: bad window ID %ld\n",
                 req->drawable);
    }
    break;

  case X_CreateColormap:
    {
      xCreateColormapReq     *req = (xCreateColormapReq *) buf;
      const int               numCmap = cmapinfoTable->numCmap++;
      int                     ii = 0;

      cmapinfoTable->cmapTable[numCmap].numColors = 0;
      cmapinfoTable->cmapTable[numCmap].cmap = req->mid;
      cmapinfoTable->cmapTable[numCmap].visualID = req->visual;
      cmapinfoTable->cmapTable[numCmap].fd = fd;
      for (; ii < NUM_COLORS; ii++)
        cmapinfoTable->cmapTable[numCmap].colors[ii].pixel = ii,
          cmapinfoTable->cmapTable[numCmap].numAlloc[ii] = 0;
    }
    break;

  case X_FreeColormap:
    {
      xResourceReq           *req = (xResourceReq *) buf;

      deleteCmap (cmapinfoTable, req->id);
    }
    break;

  case X_CopyColormapAndFree:
    {

/* create a new colormap and copy the old colormap to it */

      xCopyColormapAndFreeReq *req = (xCopyColormapAndFreeReq *) buf;
      int                     i,
                              n = cmapinfoTable->numCmap;

      cmapinfo = getcmapinfo (req->srcCmap, cmapinfoTable);
      cmapinfoTable->cmapTable[n].numColors =
        cmapinfo->numColors;
      for (i = 0; i < NUM_COLORS; i++)
      {
        cmapinfoTable->cmapTable[n].colors[i] =
          cmapinfo->colors[i];
        cmapinfoTable->cmapTable[n].numAlloc[i] =
          cmapinfo->numAlloc[i];
      }
      cmapinfoTable->numCmap++;
    }
    break;

  case X_AllocColor:            /* needs reply */
    {
      xAllocColorReq         *req = (xAllocColorReq *) buf;
      xAllocColorReply       *reply = (xAllocColorReply *) newmsg;
      int                     found = FALSE,
                              ii = 0, red, green, blue;

      cmapinfo = getcmapinfo (req->cmap, cmapinfoTable);
      if (cmapinfo->visualID == PSEUDOCOLOR_VISUAL) {
	for (; ii < NUM_COLORS; ii++)
	  if ((cmapinfo->colors[ii].red == req->red) &&
	      (cmapinfo->colors[ii].green == req->green) &&
	      (cmapinfo->colors[ii].blue == req->blue) &&
	      (cmapinfo->numAlloc[ii] > 0))
	  {
	    cmapinfo->numAlloc[ii]++;
	    found = TRUE;
	    break;
	  }

  /* allocate a new pixel, then return it (whether allocated or not) 
      increment the number of people allocated to this color */

	if (!found)
	{
	  for (ii = 0; ii < NUM_COLORS; ii++)
	    if (!cmapinfo->numAlloc[ii])
	      break;

	  if (ii < NUM_COLORS)
	    cmapinfo->colors[ii].red = req->red,
	      cmapinfo->colors[ii].green = req->green,
	      cmapinfo->colors[ii].blue = req->blue,
	      cmapinfo->numAlloc[ii]++,
	      cmapinfo->numColors++;

	}
	reply->pixel = ii;
      } else {
	red = req->red >> 8;
	green = req->green >> 8;
	blue = req->blue >> 8;
	reply->pixel = red | ( green << 8) | ( blue << 16);
      }
      reply->length = 0;
      reply->red = req->red; 		/* return original RGB values */
      reply->green = req->green; 
      reply->blue = req->blue;
      *newlen = sizeof (*reply);
    }
    break;

  case X_AllocNamedColor:     /* needs reply */
    {
      xAllocNamedColorReq    *req = (xAllocNamedColorReq *) buf;
      xAllocNamedColorReply  *reply =
      (xAllocNamedColorReply *) newmsg;
      char                    name[256];
      XColor                  exact;
      int                     found = FALSE,
                              ii = 0;

/* use the real server to get the mapping from the name to RGB values */

      strncpy (name, (char *) buf + sizeof (*req), req->nbytes);
      XParseColor (THE_DISPLAY,
                   DefaultColormap (THE_DISPLAY, DefaultScreen (THE_DISPLAY)),
                   name, &exact);
      cmapinfo = getcmapinfo (req->cmap, cmapinfoTable);
      if ( cmapinfo->visualID == PSEUDOCOLOR_VISUAL) {
	for (; ii < NUM_COLORS; ii++)
	{
	  if ((cmapinfo->colors[ii].red == exact.red) &&
	      (cmapinfo->colors[ii].green == exact.green) &&
	      (cmapinfo->colors[ii].blue == exact.blue))
	  {
	    cmapinfo->numAlloc[ii]++;
	    found = TRUE;
	    break;
	  }
	}

/* need to allocate color in vector here */

	if (!found)
	{
	  for (ii = 0; ii < NUM_COLORS; ii++)
	    if (!cmapinfo->numAlloc[ii])
	      break;

	  if (ii < NUM_COLORS)
	    cmapinfo->colors[ii] = exact,
	      cmapinfo->numAlloc[ii]++, cmapinfo->numColors++;

	}
	reply->pixel = ii,
	  reply->exactRed = exact.red, reply->exactGreen = exact.green,
	  reply->exactBlue = exact.blue, reply->screenRed = exact.red,
	  reply->screenGreen = exact.green, reply->screenBlue = exact.blue;
      } else {
	reply->pixel = exact.red | ( exact.green << 8) | ( exact.blue << 16);
	reply->exactRed = exact.red; 
	reply->exactGreen = exact.green; 
	reply->exactBlue = exact.blue;
	reply->screenRed = exact.red; 
	reply->screenGreen = exact.green; 
	reply->screenBlue = exact.blue;
      }

/* increment the number of people allocated to this color */

      *newlen = sizeof (*reply);
    }
    break;

/* both of these are just hacked so that I've got a reply */

  case X_AllocColorCells:     /* needs reply */
    {
      xAllocColorCellsReq    *req = (xAllocColorCellsReq *) buf;
      xAllocColorCellsReply  *reply =
      (xAllocColorCellsReply *) newmsg;
      unsigned long          *pixel;
      int                     ii = 0;

      cmapinfo = getcmapinfo (req->cmap, cmapinfoTable);
      reply->nPixels = req->colors;
      reply->nMasks = req->planes;
      pixel = (unsigned long *) buf + sizeof (*req);

      for (; ii < reply->nPixels; ii++)
        *pixel++ = ii;

      for (ii = 0; ii < reply->nMasks; ii++)
        *pixel++ = (1 << ii);

      reply->length = reply->nPixels + reply->nMasks;
      *newlen = sizeof (*reply) + (reply->nPixels << 2) +
        (reply->nMasks << 2);
    }
    break;

  case X_AllocColorPlanes:      /* needs reply */
    {
      xAllocColorPlanesReq   *req = (xAllocColorPlanesReq *) buf;
      xAllocColorPlanesReply *reply =
      (xAllocColorPlanesReply *) newmsg;
      unsigned long          *pixel;
      int                     ii = 0;

      cmapinfo = getcmapinfo (req->cmap, cmapinfoTable);
      reply->nPixels = req->colors;
      pixel = (unsigned long *) (buf + sizeof (*req));

      for (; ii < reply->nPixels; ii++) {
        *pixel++ = ii;
      }

      reply->redMask = reply->greenMask = reply->blueMask = 0;
      reply->length = reply->nPixels;

      *newlen = sizeof (*reply) + (reply->nPixels << 2);
    }
    break;

  case X_FreeColors:
    {
      xFreeColorsReq         *req = (xFreeColorsReq *) buf;
      unsigned long          *pixel;
      int                     ii = 0;

      pixel = (unsigned long *) (buf + sizeof (*req));
      cmapinfo = getcmapinfo (req->cmap, cmapinfoTable);
      if ( cmapinfo->visualID == PSEUDOCOLOR_VISUAL) {
	for (; ii < req->length - 3; ii++, pixel++) {
	  if (*pixel < NUM_COLORS) {
	    cmapinfo->numAlloc[*pixel]--;
	  } else {
	    fprintf (stderr, "pixel out of range %ld\n", *pixel);
	  }
	}
      } 
	

    }
    break;

/* both store colors and store named colors should give errors for true color
   visuals, but we might as well be nicer than the standard X server. */

  case X_StoreColors:
    {
      xStoreColorsReq        *req = (xStoreColorsReq *) buf;
      int                     ncolors = (req->length - 2) / 3;
      xColorItem             *color = (xColorItem *) (buf + sizeof (*req));
      int                     ii;

      cmapinfo = getcmapinfo (req->cmap, cmapinfoTable);
      if ( cmapinfo->visualID == PSEUDOCOLOR_VISUAL) {
	for ( ii = 0; ii < ncolors; ii++) {
	  if ( color->pixel < NUM_COLORS) {
	    cmapinfo->colors[ color->pixel].red = color->red;
	    cmapinfo->colors[ color->pixel].green = color->green;
	    cmapinfo->colors[ color->pixel].blue = color->blue;
	    cmapinfo->colors[ color->pixel].pixel = color->pixel;
	  } else {
	    fprintf (stderr, "pixel out of range %lu\n", ( unsigned long) color->pixel);
	  }
	  color++;
	}
      } 

/* this request is simply ignored by the TrueColor Visual */
    }
    break;

  case X_StoreNamedColor:
    {
      xStoreNamedColorReq    *req = (xStoreNamedColorReq *) buf;
      XColor                  exact,
                              screen;
      int                     ind = req->pixel;
      char                    colorname[256];

      strncpy (colorname, (char *) buf + sizeof (*req), req->nbytes);
      XLookupColor (THE_DISPLAY,
                    DefaultColormap (THE_DISPLAY,
                                     DefaultScreen (THE_DISPLAY)),
                    colorname, &exact, &screen);
      cmapinfo = getcmapinfo (req->cmap, cmapinfoTable);
      if ( cmapinfo->visualID == PSEUDOCOLOR_VISUAL) {
	if ((ind >= 0) && (ind < NUM_COLORS)) {
	  cmapinfo->colors[ind].red = exact.red,
	  cmapinfo->colors[ind].green = exact.green,
	  cmapinfo->colors[ind].blue = exact.blue,
	  cmapinfo->colors[ind].pixel = ind;
	} else {
	  fprintf (stderr, "pixel out of range %d\n", ind);
	}
      } 

/* this request is ignored by the truecolor visual */

    }
    break;

  case X_QueryColors:         /* needs reply */
    {
      xQueryColorsReq     *req = (xQueryColorsReq *) buf;
      xQueryColorsReply   *reply = (xQueryColorsReply *) newmsg;
      xrgb		  *rgb = (xrgb *)(newmsg+sizeof(xQueryColorsReply));
      int		  nColors = req->length - 2, ii;
      long		  *pixels = ( long *)( buf + sizeof( xQueryColorsReq));

      cmapinfo = getcmapinfo (req->cmap, cmapinfoTable);
      if ( cmapinfo->visualID == PSEUDOCOLOR_VISUAL) {
	for ( ii = 0; ii < nColors; ii++) {
	  rgb->red = cmapinfo->colors[ pixels[ ii]].red;
	  rgb->green = cmapinfo->colors[ pixels[ ii]].green;
	  rgb->blue = cmapinfo->colors[ pixels[ ii]].blue;
	  rgb++;
	}
      } else if ( cmapinfo->visualID == TRUECOLOR_VISUAL) {

/* just pull the colors out of the pixel */

	for ( ii = 0; ii < nColors; ii++) {
	  rgb->red = (pixels[ ii] & 0xff) << 8;
	  rgb->green = pixels[ ii] & 0xff00;
	  rgb->blue = (pixels[ ii] & 0xff0000) >> 8;
	  rgb++;
	}
      }
      reply->nColors = nColors;
      reply->length = 2*nColors;
      *newlen = sizeof( *reply) + nColors * sizeof( xrgb);
    }
    break;

  case X_LookupColor:         /* needs reply */
    {
      xLookupColorReq        *req = (xLookupColorReq *) buf;
      xLookupColorReply      *reply = (xLookupColorReply *) newmsg;
      char                   *colorname = (char *) buf + sizeof (*req);
      XColor                  exact,
                              screen;

      XLookupColor (THE_DISPLAY,
                    DefaultColormap (THE_DISPLAY, DefaultScreen (THE_DISPLAY)),
                    colorname, &exact, &screen);
      reply->exactRed = exact.red;
      reply->exactGreen = exact.green;
      reply->exactBlue = exact.blue;
      reply->screenRed = screen.red;
      reply->screenGreen = screen.green;
      reply->screenBlue = screen.blue;
      *newlen = sizeof (*reply);
    }
    break;

  case X_QueryBestSize:       /* needs reply */
    {
      xQueryBestSizeReply    *reply =
      (xQueryBestSizeReply *) newmsg;

      reply->width = 16;        /* guesses.. */
      reply->height = 16;
      *newlen = sizeof (*reply);
    }
    break;

/* delete the extension request from the client and insert our reply that
   the extension exists */

  case X_QueryExtension:
    {
      xQueryExtensionReply   *reply =
      (xQueryExtensionReply *) newmsg;
      char                   *extname,
                            **extlist;

      extname = (char *) buf + sizeof (xQueryExtensionReq);
      if (strncmp (extname, PRINTNAME, strlen (PRINTNAME)) == 0)
      {

/* set up our fake reply */

        reply->length = 0;
        reply->present = True;

/* find out the number of extensions supported by the server, and use that
   for basing the major opcode # on */

        extlist = XListExtensions (THE_DISPLAY, &nextensions);
        reply->major_opcode = EXTENSION_BASE + nextensions + 1;
        THE_OPCODE = EXTENSION_BASE + nextensions + 1;
        reply->first_event = 0;
        reply->first_error = 0;
      }
      else
      {
        reply->length = 0;
        reply->present = False;
      }
      *newlen = sizeof (*reply);
    }
    break;

  case X_ListExtensions:        /* needs reply */
    {
      xListExtensionsReply   *reply =
      (xListExtensionsReply *) newmsg;
      int		     n;

      reply->nExtensions = 1;   /* just this extension */

/* the length of the string for the name of the extension is preceded by
   a 1 character length */

      n = sizeof( *reply);
      newmsg[ n++] = strlen( PRINTNAME);
      strcpy ((char *) &newmsg[ n], PRINTNAME);
      reply->length = (strlen (PRINTNAME) + 1 + 3) >> 2;
      *newlen = sizeof (*reply) + (reply->length << 2);
    }
    break;

  case X_GetKeyboardMapping:    /* needs reply */
    {
      xGetKeyboardMappingReq *req =
      (xGetKeyboardMappingReq *) buf;
      xGetKeyboardMappingReply *reply =
      (xGetKeyboardMappingReply *) newmsg;

      reply->keySymsPerKeyCode = 1;
      reply->length = req->count;
      *newlen = sizeof (*reply) + (reply->length << 2);
    }
    break;

  case X_GetKeyboardControl:    /* needs reply */
    {
      xGetKeyboardControlReply *reply =
      (xGetKeyboardControlReply *) newmsg;

/* fake it totally, don't even bother with the masks */

      reply->globalAutoRepeat = False;
      reply->ledMask = 0;
      reply->keyClickPercent = 0;
      reply->bellPercent = 0;
      reply->bellPitch = 0;
      reply->bellDuration = 0;
      reply->length = 5;
      *newlen = sizeof (*reply) + (reply->length << 2);
    }
    break;

  case X_GetPointerControl:   /* needs reply */
    {
      xGetPointerControlReply *reply =
      (xGetPointerControlReply *) newmsg;

      reply->accelNumerator = 1;
      reply->accelDenominator = 1;
      *newlen = sizeof (*reply);
    }
    break;

  case X_GetScreenSaver:        /* needs reply */
    {
      xGetScreenSaverReply   *reply =
      (xGetScreenSaverReply *) newmsg;

      reply->timeout = 10;
      reply->interval = 10;
      reply->preferBlanking = FALSE;
      reply->allowExposures = FALSE;
      *newlen = sizeof (*reply);
    }
    break;

  case X_ListHosts:           /* no other hosts */
    {
      xListHostsReply        *reply = (xListHostsReply *) newmsg;

      reply->nHosts = 0;
      *newlen = sizeof (*reply);
    }
    break;

  case X_GetPointerMapping:   /* generate a totally bogus response */
    {
      xGetPointerMappingReply *reply =
      (xGetPointerMappingReply *) newmsg;

      reply->nElts = 0;
      *newlen = sizeof (*reply);
    }
    break;

  case X_GetModifierMapping:    /* needs reply */
    {
      xGetModifierMappingReply *reply =
      (xGetModifierMappingReply *) newmsg;

      reply->numKeyPerModifier = 0;
      *newlen = sizeof (*reply);
    }
    break;

/*- Unimplemented. */
  case X_AllowEvents:
  case X_Bell:
  case X_ChangeActivePointerGrab:
  case X_ChangeHosts:
  case X_ChangeKeyboardControl:
  case X_ChangeKeyboardMapping:
  case X_ChangePointerControl:
  case X_ChangeProperty:
  case X_ChangeSaveSet:
  case X_CirculateWindow:
  case X_CloseFont:
  case X_ConfigureWindow:
  case X_ConvertSelection:
  case X_CopyPlane:
  case X_CreateCursor:
  case X_CreateGlyphCursor:
  case X_CreatePixmap:          /* FTM, these are ignored */
  case X_DeleteProperty:
  case X_DestroySubwindows:   /* I really should do something here */
  case X_ForceScreenSaver:
  case X_FreeCursor:
  case X_GrabButton:
  case X_GrabKey:
  case X_GrabServer:
  case X_InstallColormap:
  case X_KillClient:
  case X_ListInstalledColormaps:    /* needs reply */
  case X_MapSubwindows:
  case X_MapWindow:
  case X_NoOperation:
  case X_PolyFillArc:
  case X_QueryKeymap:         /* needs reply */
  case X_RecolorCursor:
  case X_ReparentWindow:
  case X_RotateProperties:
  case X_SendEvent:
  case X_SetAccessControl:
  case X_SetCloseDownMode:
  case X_SetFontPath:
  case X_SetInputFocus:
  case X_SetModifierMapping:
  case X_SetPointerMapping:
  case X_SetScreenSaver:
  case X_SetSelectionOwner:
  case X_UngrabButton:
  case X_UngrabKey:
  case X_UngrabKeyboard:
  case X_UngrabPointer:
  case X_UngrabServer:
  case X_UninstallColormap:
  case X_UnmapSubwindows:
  case X_UnmapWindow:
  case X_WarpPointer:

  default:
    fprintf( stderr, "Unimplemented request opcode %d ", request);
    if (( request > 0) && ( request < sizeof( opNames)/sizeof( opNames[ 0]))) {
	fprintf( stderr, "(%s)", opNames[ request]);
    }
    fprintf( stderr, "\n");
    break;
  }

  return True;                  /* maybe this will be useful in the future */
}

/*- end handlreq.c
*/
