/*-
|> File
|| printer.h
||
|> Description
||
||
|> Comments
||
||
|> History
|| 950jj _mf Created.
||
||==================================================================|>
*/
#ifndef _dir_printer_h
#define _dir_printer_h

#ifndef _NOIDENT
#ident "$Id: printer.h,v 2.4 1995/11/23 17:00:44 mreynold Exp $"
#endif
#include <stdio.h>
#include <X11/Xlib.h>

#define TRUE    1
#define FALSE   0
#define BACKLOG   5
#define STATICMAXFD 32
#define NUM_COLORS  256
#define NUMWIN    64
#define NUMGC     64
#define NUMATOM     64
#define NUMFONT   64
#define NUMCMAP     8
#define MAXFONTS  1024
#define MAXCACHEFONTS 128
#define FONTFILE  "/usr/lib/X11/printfonts.dir"
#define MAXFID    64

#include "ps_types.h"

extern lookupRec        XFN_NAMES[];
extern Display         *THE_DISPLAY;
extern printOptionsRec  PRINT_OPTIONS;  /* global ( only one of it, anyway) */
extern int              debug;

void initprocs( struct PrintClient *pc,
		int		   fd);

winfoPtr getwinfo( const unsigned long win,
		   const winfoTablePtr table);

cmapinfoPtr getcmapinfo( const unsigned long cmap,
			 const cmapinfoTablePtr table);

void printImageGrey( unsigned char *image,
		     int x,
		     int y,
		     int width,
		     int height,
		     int depth,
		     XColor *colors,
		     int numColors,
		     FILE * fp,
		     int indexSupport);

void printImage24( unsigned char     *image,
		  int                 x,
		  int                 y,
		  int                 width,
		  int                 height,
		  int                 depth,
		  FILE               *fp);

char *getPostName( char *xfont);

void setGcvalues( FD 		fd,
		  FILE 	        *fp,
		  XGCValues 	*gcvp,
		  unsigned long value_mask,
		  unsigned long *request,  /* each val is a long */
		  Colormap 	cmap);

void copyGcvalues( XGCValues *gcvp,
		  XGCValues *srcGcvp,
		  unsigned long value_mask);

void cleararea( FILE * fp,
	        Window win,
	        XWindowAttributes *attr,
	        int x,
	        int y,
	        int width,
	        int height);

void setCurrGc( FD 		fd,
	        FILE 		*fp,
	        gcinfoPtr	gcinfo,
	        Colormap 	cmap);

void polypoint( FILE * fp,
	       Window win,
	       XGCValues *gcv,
	       int npoint,
	       int coordmode,
	       XPoint *points);

void polysegment( FILE * fp,
		 Window win,
		 XGCValues *gcv,
		 int nseg,
		 XSegment *segments);

void polyrectangle( FILE * fp,
		   Window win,
		   XGCValues *gcv,
		   int nrect,
		   XRectangle *rectangles);

void polyarc( FILE * fp,
	      Window win,
	      XGCValues *gcv,
	      int narc,
	      xArc * arcs);

void putimage( int fd,
	       FILE * fp,
	       Window win,
	       XGCValues *gcv,
	       int depth,
	       int width,
	       int height,
	       int x,
	       int y,
	       int leftpad,
	       int format,
	       int numColors,
	       XColor *colors,
	       unsigned char *data);
 
void polyarc( FILE * fp,
	      Window win,
	      XGCValues *gcv,
	      int narc,
	      xArc * arcs);

char  **readStrvec (char *filename);
void
copyarea (FILE * fp,
          Drawable src,
          Window win,
          int src_x,
          int src_y,
          int dstX,
          int dstY,
          int width,
          int height,
          int numColors,
          XColor *colors);

void initPrintClients( struct PrintClient pcs[],
                       const int numclients);

int initConnection (int clientFd);

int readLoop( int fd,
	      char *msg,
	      int length);

Bool DecodeRequest( const FD fd,
		    unsigned char *const buf,
		    unsigned char *const newmsg,
		    int *const newlen);

void initTables();

char *insertQuoteChar( char     *str, 
                       char     *charsToQuote,
                       int      quoteChar);

#endif

/*- end printer.h
*/
